#if !defined( _JVizObj_h )
#define _JVizObj_h
#include "JAddObj.h"
#include "JCriticalSection.h"


class 
#if defined(_EXTERNAL_DLL)
  DllExport
#else
  DllImport 
#endif
JVizObj : public JAddObj {
  protected:
  public:
    enum {
      X, Y, Z, SIGNAL1, SIGNAL2, SIGNAL3, SIGNAL4, SIGNAL5, TIMER_SAMPLED, CALIBRATING, SEND_CALIBRATION };

    virtual const char* className() const;
    virtual JObject* clone() const;
    JVizObj();
    virtual void draw(JGraphics g, int x, int y, int w, int h);
    virtual boolean inputAllowed(int n);
    virtual JString inputTag(int n);
    virtual JString outputTag(int n);
    virtual JFRect inputArea(int n);
    virtual JFRect outputArea(int n);
    virtual int inputFace(int n);
    virtual int outputFace(int n);
    virtual JFPoint inputPoint(int n, JLinkObj& link);
    virtual JFPoint outputPoint(int n, JLinkObj& link);
    virtual void engine(int n, JLinkObj& link);
    virtual JArray getProperties();
    virtual boolean updateProperty(JProperty& prop);
	virtual void access(int n, JLinkObj& link, const JDataType& data);
	virtual int outputType(int n);
  private:
      void startCalibration();
      void endCalibration();

    // inputs
    int x;
	int y;
	int z;
	int signal1;
	int signal2;
	int signal3;
	int signal4;
	int signal5;

    // calibration data
    int minX;
    int maxX;
    int minY;
    int maxY;
    int minZ;
    int maxZ;
    int calibrated;
    int initial_X_values_set;
    int initial_Y_values_set;
    int initial_Z_values_set;

    int minSignal1;
    int maxSignal1;
    int initial_signal1_values_set;

    int minSignal2;
    int maxSignal2;
    int initial_signal2_values_set;

    int minSignal3;
    int maxSignal3;
    int initial_signal3_values_set;

    int minSignal4;
    int maxSignal4;
    int initial_signal4_values_set;

    int minSignal5;
    int maxSignal5;
    int initial_signal5_values_set;

    int calibration_data_sent;

    // controls
    int timer_sampled;
    int calibrating;
    int send_calibration;

    // variables
    JCriticalSection csb;

    // outputs
    JBlock dataOut;
};


#endif
