#include "JVizAttrObj.h"
#include "JInteger.h"
#include "JIntegerData.h"
#include "JStringData.h"
#include "JIntegerProperty.h"
#include "JIntegerListProperty.h"
#include "JStringProperty.h"
#include "JLinkObj.h"
#include "JBytesData.h"


char* theJVizAttrObj = JVizAttrObj().Register();


void JVizAttrObj::writeContent(JOutputStream& os) {
  JAddObj::writeContent(os);
  putObject(os, "property", property);
}

void JVizAttrObj::readContent(JDictionary& dict) {
  JAddObj::readContent(dict);
  JObject* obj_property = getObject( dict, "property");
  if ( obj_property ) property = *(JString*)obj_property;
}

const char* JVizAttrObj::className() const { return "JVizAttrObj";}


JObject* JVizAttrObj::clone() const { return new JVizAttrObj(*this);}


// class constructor
JVizAttrObj::JVizAttrObj() {
  igm = 1 + 1;
  ogm = 1;
  attrValue = 0;
}


void JVizAttrObj::draw(JGraphics g, int x, int y, int w, int h) {
  JRect rect(x, y, w, h);
  drawText(g, JString("Viz: " ) + property, rect);
}


boolean JVizAttrObj::inputAllowed(int n)
{ return !inputSet(n).last();}
JString JVizAttrObj::inputTag(int n) {
  char* tag[] = {
    "name",
    "attrValue" };
  return( tag[n] );
}


int JVizAttrObj::outputType( int n ) {
  if ( n == 0 ) return JStringData::id;
  return JIntegerData::id;
}
int JVizAttrObj::inputType( int n ) {
  if ( n == 0 ) return JStringData::id;
  return JIntegerData::id;
}
JString JVizAttrObj::outputTag(int n) {
  char* tag[] = {
    "result" };
  return( tag[n] );
}


JFRect JVizAttrObj::inputArea(int n) {
  //if ( n < ( 1 + 1 )) {
    return leftArea( n, 0, 1 + 1, 0.1, 0.8 );
  //}
}


JFRect JVizAttrObj::outputArea(int n) {
  return rightArea(n, 0, 1);
}


int JVizAttrObj::inputFace(int n) {
  if ( n < 1 + 1 ) {
    return LEFT;
  } else {
    return TOP;
  }
}


int JVizAttrObj::outputFace(int n) {
  return RIGHT;
}


JFPoint JVizAttrObj::inputPoint(int n, JLinkObj& link) {
  return leftPoint( n, link, 0, 1 + 1, 0.1, 0.8);
}


JFPoint JVizAttrObj::outputPoint(int n, JLinkObj& link) {
  return rightPoint(n, link, 0, 1);
}


void JVizAttrObj::access(int n, JLinkObj& link, const JDataType& data) {
  if ( n == 0 ) {
    JSTRING(data) = result;
  }
}


#include <stdio.h>
void JVizAttrObj::engine(int n, JLinkObj& link) {
  switch (n) {
  case NAME:
    link.access( JStringData( name ));
    break;
  case ATTRVALUE:
    link.access(JIntegerData(attrValue));
    break;
  default:
    break;
  }
  char buf[100];
  sprintf( buf, "%d", attrValue );
  result = JString( name ) + JString( "," ) + JString( property ) + JString( "," ) + JString( buf );
  broadcast( 0 );
}


JArray JVizAttrObj::getProperties() {
  JArray properties;
  properties.append(JStringProperty("property", property));
  return properties;
}


boolean JVizAttrObj::updateProperty(JProperty& prop) {
  if (prop.getName() == JString("property")) {
    property = ((JStringProperty*)&prop)->value;
    return true;
  }
  return false;
}


