#include "JVizXlocObj.h"
#include "JInteger.h"
#include "JIntegerData.h"
#include "JStringData.h"
#include "JIntegerProperty.h"
#include "JIntegerListProperty.h"
#include "JStringProperty.h"
#include "JLinkObj.h"
#include "JBytesData.h"


char* theJVizXlocObj = JVizXlocObj().Register();


const char* JVizXlocObj::className() const { return "JVizXlocObj";}


JObject* JVizXlocObj::clone() const { return new JVizXlocObj(*this);}


// class constructor
JVizXlocObj::JVizXlocObj() {
  igm = 1 + 1;
  ogm = 1;
  xLocation = 0;
}


void JVizXlocObj::draw(JGraphics g, int x, int y, int w, int h) {
  JRect rect(x, y, w, h);
  drawText(g, JString("VizXloc"), rect);
}


boolean JVizXlocObj::inputAllowed(int n)
{ return !inputSet(n).last();}
JString JVizXlocObj::inputTag(int n) {
  char* tag[] = {
    "name",
    "xLocation" };
  return( tag[n] );
}


int JVizXlocObj::outputType( int n ) {
  if ( n == 0 ) return JStringData::id;
  return JIntegerData::id;
}
int JVizXlocObj::inputType( int n ) {
  if ( n == 0 ) return JStringData::id;
  return JIntegerData::id;
}
JString JVizXlocObj::outputTag(int n) {
  char* tag[] = {
    "result" };
  return( tag[n] );
}


JFRect JVizXlocObj::inputArea(int n) {
  //if ( n < ( 1 + 1 )) {
    return leftArea( n, 0, 1 + 1, 0.1, 0.8 );
  //}
}


JFRect JVizXlocObj::outputArea(int n) {
  return rightArea(n, 0, 1);
}


int JVizXlocObj::inputFace(int n) {
  if ( n < 1 + 1 ) {
    return LEFT;
  } else {
    return TOP;
  }
}


int JVizXlocObj::outputFace(int n) {
  return RIGHT;
}


JFPoint JVizXlocObj::inputPoint(int n, JLinkObj& link) {
  return leftPoint( n, link, 0, 1 + 1, 0.1, 0.8);
}


JFPoint JVizXlocObj::outputPoint(int n, JLinkObj& link) {
  return rightPoint(n, link, 0, 1);
}


void JVizXlocObj::access(int n, JLinkObj& link, const JDataType& data) {
  if ( n == 0 ) {
    JSTRING(data) = result;
  }
}

#include <stdio.h>
void JVizXlocObj::engine(int n, JLinkObj& link) {
  switch (n) {
  case NAME:
    link.access( JStringData( name ));
    break;
  case XLOCATION:
    link.access(JIntegerData(xLocation));
    break;
  default:
    break;
  }
  char buf[100];
  sprintf( buf, "%d", xLocation );
  result = name + JString( ",x," ) + JString( buf );
  broadcast( 0 );
}


