#include "JVizYlocObj.h"
#include "JInteger.h"
#include "JIntegerData.h"
#include "JStringData.h"
#include "JIntegerProperty.h"
#include "JIntegerListProperty.h"
#include "JStringProperty.h"
#include "JLinkObj.h"
#include "JBytesData.h"


char* theJVizYlocObj = JVizYlocObj().Register();


const char* JVizYlocObj::className() const { return "JVizYlocObj";}


JObject* JVizYlocObj::clone() const { return new JVizYlocObj(*this);}


// class constructor
JVizYlocObj::JVizYlocObj() {
  igm = 1 + 1;
  ogm = 1;
  yLocation = 0;
}


void JVizYlocObj::draw(JGraphics g, int x, int y, int w, int h) {
  JRect rect(x, y, w, h);
  drawText(g, JString("VizXloc"), rect);
}


boolean JVizYlocObj::inputAllowed(int n)
{ return !inputSet(n).last();}
JString JVizYlocObj::inputTag(int n) {
  char* tag[] = {
    "name",
    "yLocation" };
  return( tag[n] );
}


int JVizYlocObj::outputType( int n ) {
  if ( n == 0 ) return JStringData::id;
  return JIntegerData::id;
}
int JVizYlocObj::inputType( int n ) {
  if ( n == 0 ) return JStringData::id;
  return JIntegerData::id;
}
JString JVizYlocObj::outputTag(int n) {
  char* tag[] = {
    "result" };
  return( tag[n] );
}


JFRect JVizYlocObj::inputArea(int n) {
  //if ( n < ( 1 + 1 )) {
    return leftArea( n, 0, 1 + 1, 0.1, 0.8 );
  //}
}


JFRect JVizYlocObj::outputArea(int n) {
  return rightArea(n, 0, 1);
}


int JVizYlocObj::inputFace(int n) {
  if ( n < 1 + 1 ) {
    return LEFT;
  } else {
    return TOP;
  }
}


int JVizYlocObj::outputFace(int n) {
  return RIGHT;
}


JFPoint JVizYlocObj::inputPoint(int n, JLinkObj& link) {
  return leftPoint( n, link, 0, 1 + 1, 0.1, 0.8);
}


JFPoint JVizYlocObj::outputPoint(int n, JLinkObj& link) {
  return rightPoint(n, link, 0, 1);
}


void JVizYlocObj::access(int n, JLinkObj& link, const JDataType& data) {
  if ( n == 0 ) {
    JSTRING(data) = result;
  }
}

#include <stdio.h>
void JVizYlocObj::engine(int n, JLinkObj& link) {
  switch (n) {
  case NAME:
    link.access( JStringData( name ));
    break;
  case XLOCATION:
    link.access(JIntegerData(yLocation));
    break;
  default:
    break;
  }
  char buf[100];
  sprintf( buf, "%d", yLocation );
  result = name + JString( ",y," ) + JString( buf );
  broadcast( 0 );
}


