#include "JVizZlocObj.h"
#include "JInteger.h"
#include "JIntegerData.h"
#include "JStringData.h"
#include "JIntegerProperty.h"
#include "JIntegerListProperty.h"
#include "JStringProperty.h"
#include "JLinkObj.h"
#include "JBytesData.h"


char* theJVizZlocObj = JVizZlocObj().Register();


const char* JVizZlocObj::className() const { return "JVizZlocObj";}


JObject* JVizZlocObj::clone() const { return new JVizZlocObj(*this);}


// class constructor
JVizZlocObj::JVizZlocObj() {
  igm = 1 + 1;
  ogm = 1;
  zLocation = 0;
}


void JVizZlocObj::draw(JGraphics g, int x, int y, int w, int h) {
  JRect rect(x, y, w, h);
  drawText(g, JString("VizXloc"), rect);
}


boolean JVizZlocObj::inputAllowed(int n)
{ return !inputSet(n).last();}
JString JVizZlocObj::inputTag(int n) {
  char* tag[] = {
    "name",
    "zLocation" };
  return( tag[n] );
}


int JVizZlocObj::outputType( int n ) {
  if ( n == 0 ) return JStringData::id;
  return JIntegerData::id;
}
int JVizZlocObj::inputType( int n ) {
  if ( n == 0 ) return JStringData::id;
  return JIntegerData::id;
}
JString JVizZlocObj::outputTag(int n) {
  char* tag[] = {
    "result" };
  return( tag[n] );
}


JFRect JVizZlocObj::inputArea(int n) {
  //if ( n < ( 1 + 1 )) {
    return leftArea( n, 0, 1 + 1, 0.1, 0.8 );
  //}
}


JFRect JVizZlocObj::outputArea(int n) {
  return rightArea(n, 0, 1);
}


int JVizZlocObj::inputFace(int n) {
  if ( n < 1 + 1 ) {
    return LEFT;
  } else {
    return TOP;
  }
}


int JVizZlocObj::outputFace(int n) {
  return RIGHT;
}


JFPoint JVizZlocObj::inputPoint(int n, JLinkObj& link) {
  return leftPoint( n, link, 0, 1 + 1, 0.1, 0.8);
}


JFPoint JVizZlocObj::outputPoint(int n, JLinkObj& link) {
  return rightPoint(n, link, 0, 1);
}


void JVizZlocObj::access(int n, JLinkObj& link, const JDataType& data) {
  if ( n == 0 ) {
    JSTRING(data) = result;
  }
}

#include <stdio.h>
void JVizZlocObj::engine(int n, JLinkObj& link) {
  switch (n) {
  case NAME:
    link.access( JStringData( name ));
    break;
  case XLOCATION:
    link.access(JIntegerData(zLocation));
    break;
  default:
    break;
  }
  char buf[100];
  sprintf( buf, "%d", zLocation );
  result = name + JString( ",z," ) + JString( buf );
  broadcast( 0 );
}


